UpdateGateway
Updates an existing gateway.
Replaces the entire gateway configuration. Any optional field that you omit, including fields in protocolConfiguration, is reset. For information about retrieving the current configuration, see GetGateway.
Request Syntax
PUT /gateways/gatewayIdentifier/ HTTP/1.1
Content-type: application/json
{
"authorizerConfiguration": { ... },
"authorizerType": "string",
"customTransformConfiguration": {
"lambda": {
"arn": "string"
}
},
"description": "string",
"exceptionLevel": "string",
"interceptorConfigurations": [
{
"inputConfiguration": {
"passRequestHeaders": boolean,
"payloadFilter": {
"exclude": [
{ ... }
]
}
},
"interceptionPoints": [ "string" ],
"interceptor": { ... }
}
],
"kmsKeyArn": "string",
"name": "string",
"policyEngineConfiguration": {
"arn": "string",
"mode": "string"
},
"protocolConfiguration": { ... },
"protocolType": "string",
"roleArn": "string",
"wafConfiguration": {
"failureMode": "string"
}
}
URI Request Parameters
The request uses the following URI parameters.
- gatewayIdentifier
-
The identifier of the gateway to update.
Pattern:
([0-9a-z][-]?){1,100}-[0-9a-z]{10}Required: Yes
Request Body
The request accepts the following data in JSON format.
-
The updated authorizer configuration for the gateway.
Type: AuthorizerConfiguration object
Note: This object is a Union. Only one member of this object can be specified or returned.
Required: No
-
The updated authorizer type for the gateway.
Type: String
Valid Values:
CUSTOM_JWT | AWS_IAM | NONE | AUTHENTICATE_ONLYRequired: Yes
- customTransformConfiguration
-
The updated custom transformation configuration for the gateway. This configuration defines how the gateway transforms requests and responses.
Type: CustomTransformConfiguration object
Required: No
- description
-
The updated description for the gateway.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 200.
Required: No
- exceptionLevel
-
The level of detail in error messages returned when invoking the gateway.
-
If the value is
DEBUG, granular exception messages are returned to help a user debug the gateway. -
If the value is omitted, a generic error message is returned to the end user.
Type: String
Valid Values:
DEBUGRequired: No
-
- interceptorConfigurations
-
The updated interceptor configurations for the gateway.
Type: Array of GatewayInterceptorConfiguration objects
Array Members: Minimum number of 1 item. Maximum number of 2 items.
Required: No
- kmsKeyArn
-
The updated ARN of the AWS KMS key used to encrypt the gateway.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 2048.
Pattern:
arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36}Required: No
- name
-
The name of the gateway. This name must be the same as the one when the gateway was created.
Type: String
Pattern:
([0-9a-zA-Z][-]?){1,48}Required: Yes
- policyEngineConfiguration
-
The updated policy engine configuration for the gateway. A policy engine is a collection of policies that evaluates and authorizes agent tool calls. When associated with a gateway, the policy engine intercepts all agent requests and determines whether to allow or deny each action based on the defined policies.
Type: GatewayPolicyEngineConfiguration object
Required: No
- protocolConfiguration
-
The configuration for a gateway protocol. This structure defines how the gateway communicates with external services.
Type: GatewayProtocolConfiguration object
Note: This object is a Union. Only one member of this object can be specified or returned.
Required: No
- protocolType
-
The updated protocol type for the gateway.
Type: String
Valid Values:
MCPRequired: No
- roleArn
-
The updated IAM role ARN that provides permissions for the gateway.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 2048.
Pattern:
arn:aws(-[^:]+)?:iam::([0-9]{12})?:role/.+Required: Yes
- wafConfiguration
-
The updated AWS WAF configuration for the gateway.
Type: WafConfiguration object
Required: No
Response Syntax
HTTP/1.1 202
Content-type: application/json
{
"authorizerConfiguration": { ... },
"authorizerType": "string",
"createdAt": "string",
"customTransformConfiguration": {
"lambda": {
"arn": "string"
}
},
"description": "string",
"exceptionLevel": "string",
"gatewayArn": "string",
"gatewayId": "string",
"gatewayUrl": "string",
"interceptorConfigurations": [
{
"inputConfiguration": {
"passRequestHeaders": boolean,
"payloadFilter": {
"exclude": [
{ ... }
]
}
},
"interceptionPoints": [ "string" ],
"interceptor": { ... }
}
],
"kmsKeyArn": "string",
"name": "string",
"policyEngineConfiguration": {
"arn": "string",
"mode": "string"
},
"protocolConfiguration": { ... },
"protocolType": "string",
"roleArn": "string",
"status": "string",
"statusReasons": [ "string" ],
"updatedAt": "string",
"wafConfiguration": {
"failureMode": "string"
},
"webAclArn": "string",
"workloadIdentityDetails": {
"workloadIdentityArn": "string"
}
}
Response Elements
If the action is successful, the service sends back an HTTP 202 response.
The following data is returned in JSON format by the service.
-
The updated authorizer configuration for the gateway.
Type: AuthorizerConfiguration object
Note: This object is a Union. Only one member of this object can be specified or returned.
-
The updated authorizer type for the gateway.
Type: String
Valid Values:
CUSTOM_JWT | AWS_IAM | NONE | AUTHENTICATE_ONLY - createdAt
-
The timestamp when the gateway was created.
Type: Timestamp
- customTransformConfiguration
-
The custom transformation configuration for the gateway. This configuration defines how the gateway transforms requests and responses.
Type: CustomTransformConfiguration object
- description
-
The updated description of the gateway.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 200.
- exceptionLevel
-
The level of detail in error messages returned when invoking the gateway.
-
If the value is
DEBUG, granular exception messages are returned to help a user debug the gateway. -
If the value is omitted, a generic error message is returned to the end user.
Type: String
Valid Values:
DEBUG -
- gatewayArn
-
The Amazon Resource Name (ARN) of the updated gateway.
Type: String
Pattern:
arn:aws(|-cn|-us-gov):bedrock-agentcore:[a-z0-9-]{1,20}:[0-9]{12}:gateway/([0-9a-z][-]?){1,48}-[a-z0-9]{10} - gatewayId
-
The unique identifier of the updated gateway.
Type: String
Pattern:
([0-9a-z][-]?){1,100}-[0-9a-z]{10} - gatewayUrl
-
An endpoint for invoking the updated gateway.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 1024.
- interceptorConfigurations
-
The updated interceptor configurations for the gateway.
Type: Array of GatewayInterceptorConfiguration objects
Array Members: Minimum number of 1 item. Maximum number of 2 items.
- kmsKeyArn
-
The updated ARN of the KMS key used to encrypt the gateway.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 2048.
Pattern:
arn:aws(|-cn|-us-gov):kms:[a-zA-Z0-9-]*:[0-9]{12}:key/[a-zA-Z0-9-]{36} - name
-
The name of the gateway.
Type: String
Pattern:
([0-9a-zA-Z][-]?){1,48} - policyEngineConfiguration
-
The updated policy engine configuration for the gateway.
Type: GatewayPolicyEngineConfiguration object
- protocolConfiguration
-
The configuration for a gateway protocol. This structure defines how the gateway communicates with external services.
Type: GatewayProtocolConfiguration object
Note: This object is a Union. Only one member of this object can be specified or returned.
- protocolType
-
The updated protocol type for the gateway.
Type: String
Valid Values:
MCP - roleArn
-
The updated IAM role ARN that provides permissions for the gateway.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 2048.
Pattern:
arn:aws(-[^:]+)?:iam::([0-9]{12})?:role/.+ - status
-
The current status of the updated gateway.
Type: String
Valid Values:
CREATING | UPDATING | UPDATE_UNSUCCESSFUL | DELETING | READY | FAILED - statusReasons
-
The reasons for the current status of the updated gateway.
Type: Array of strings
Array Members: Minimum number of 0 items. Maximum number of 100 items.
Length Constraints: Minimum length of 0. Maximum length of 2048.
- updatedAt
-
The timestamp when the gateway was last updated.
Type: Timestamp
- wafConfiguration
-
The AWS WAF configuration for the gateway.
Type: WafConfiguration object
- webAclArn
-
The Amazon Resource Name (ARN) of the AWS WAF web ACL associated with the gateway.
Type: String
Length Constraints: Minimum length of 1. Maximum length of 2048.
Pattern:
arn:[a-z0-9\-]+:wafv2:[a-z0-9\-]+:[0-9]{12}:regional/webacl/.+ - workloadIdentityDetails
-
The workload identity details for the updated gateway.
Type: WorkloadIdentityDetails object
Errors
For information about the errors that are common to all actions, see Common Error Types.
- AccessDeniedException
-
This exception is thrown when a request is denied per access permissions
HTTP Status Code: 403
- ConflictException
-
This exception is thrown when there is a conflict performing an operation
HTTP Status Code: 409
- InternalServerException
-
This exception is thrown if there was an unexpected error during processing of request
HTTP Status Code: 500
- ResourceNotFoundException
-
This exception is thrown when a resource referenced by the operation does not exist
HTTP Status Code: 404
- ServiceQuotaExceededException
-
This exception is thrown when a request is made beyond the service quota
HTTP Status Code: 402
- ThrottlingException
-
This exception is thrown when the number of requests exceeds the limit
HTTP Status Code: 429
- ValidationException
-
The input fails to satisfy the constraints specified by the service.
HTTP Status Code: 400
See Also
For more information about using this API in one of the language-specific AWS SDKs, see the following: